<?php

/**
 * no_bonifica_servicios actions.
 *
 * @package    nomina
 * @subpackage no_bonifica_servicios
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_bonifica_serviciosActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_BONIFICA_SERVICIOS',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_PERIODO',
        'NO_TIPO_PERIODO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_BONIFICA_SERVICIOS',
            'num_doc' => 'NO_BONIFICA_SERVICIOS'
        ),
        'NO_PERIODO' =>
        array(
            'id_periodo' => 'NO_BONIFICA_SERVICIOS'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_BONIFICA_SERVICIOS' =>
        array(
            'id_bonifica_servicios' => 'id_ded_noley',
            'id_periodo' => 'id_periodo',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'fecha_ingresa' => 'fecha_ingresa',
            'fecha_bonifica' => 'fecha_bonifica',
            'estado' => 'estado'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_PERIODO' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'descripcion' => 'descripcion_periodo'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_BONIFICA_SERVICIOS' => array(
            'id_bonifica_servicios,a' => array('!=' => array(-1)),
            'id_bonifica_servicios,b' => array('=' => array('id_bonifica_servicios')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_periodo' => array('=' => array('id_periodo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_bonifica_servicios'; //identificador de la tabla
    protected $id_names = array('id_bonifica_servicios'); //llave primaria
    protected $field_names = array('id_periodo', 'id_tipo_doc', 'num_doc', 'fecha_ingresa', 'fecha_bonifica', 'estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_BONIFICA_SERVICIOS'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    protected $campo_fecha_sistema = array();


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_bonifica_servicios'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();

            $logger->info("Entro a Add");


            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];



            $sql = <<<EOD
update NO_BONIFICA_SERVICIOS set estado = 0 
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc and estado = 1   
EOD;

            $this->conn->execute($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            /*
             * Manejo de errores
             */
            try {

                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                $num_doc = $list_data_post[0]['num_doc'];
                $fecha_ini = $list_data_post[0]['fecha_bonifica'];

                $sql = <<<EOD
SELECT * 
FROM NO_BONIFICA_SERVICIOS
where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc 
and estado = 1              
EOD;

                $records = CN_TABLE::executeSQL($sql);


                $sql = <<<EOD
SELECT ID_CONCEP_BONIF FROM NO_PARAM_CONCEP
EOD;

                $results = CN_TABLE::executeSQL($sql);

                $id_concep_bonif = $results[0]['id_concep_bonif'];

                $sql = <<<EOD
SELECT * FROM NO_PERIODO WHERE estado = 1 and activo = 1 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $id_anhos = $results[0]['id_anhos'];
                $id_meses = $results[0]['id_meses'];
                $id_periodo = $results[0]['id_periodo'];
                $id_tipo_periodo = $results[0]['id_tipo_periodo'];
                $fecha_desde = $results[0]['fecha_ini'];
                $fecha_hasta = $results[0]['fecha_fin'];

                $date1 = new DateTime($fecha_ini);
                $date2 = new DateTime($fecha_desde);
                $date3 = new DateTime($fecha_hasta);

                $num_dias = 30;

                /**
                 * Se elimina registro de bonificacion en el periodo actual - 20130904
                 */
                $sql = <<<EOD
delete from NO_CONCEPTO_PERIODO 
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc 
    and id_concep_nomina = $id_concep_bonif and periodo = $id_periodo   
EOD;

                $this->conn->execute($sql);

                //Validacion de fechas
                if ($date1 <= $date3 && $date1 >= $date2) {

                    $sql = <<<EOD
INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,PORCENTAJE,NUM_DIAS)
    VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_bonif,
        to_date('01/$id_meses/$id_anhos','DD/MM/YYYY'),last_day(to_date('01/$id_meses/$id_anhos','DD/MM/YYYY')),
            0, $num_dias )
EOD;
                    $this->conn->execute($sql);


                    $sql = <<<EOD
update NO_BONIFICA_SERVICIOS set estado = 0 
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc 
    and estado = 1    
EOD;

                    $this->conn->execute($sql);

                    $sql = <<<EOD
INSERT INTO NO_BONIFICA_SERVICIOS (ID_TIPO_DOC,NUM_DOC,FECHA_INGRESA,FECHA_BONIFICA,ESTADO,ID_PERIODO)
    VALUES($id_tipo_doc,$num_doc,to_date('$fecha_ini','YYYY-MM-DD HH24:MI:SS'),
        to_date('$fecha_ini','YYYY-MM-DD HH24:MI:SS') + interval '1' year , 1, $id_periodo)
EOD;

                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
